#!/bin/bash 
VERSION=1.3
###by jiwo.org

####
INSTALLTYPE=0  ### 0:簲װ; 1:ذװ
PKTURLBASE="http://www.jiwo.net/musts/download/"
TMPDIR="/tmp/"
DOWNFILE=$TMPDIR"mustc.tgz"

####ж
if [ "$1" = "-h" -o "$1" = "--help" -o "$1" = "--h" ] ; then
	echo "mustc $VERSION"
	echo "------------------------------------------------------------------------"
	echo "| Help: mustc server monitor, made by jiwo tech.                        |"
	echo "------------------------------------------------------------------------"
	echo "you can directly input pkt file or no any input let install from internet."
	echo "Example:"
	echo "	$0 mustc_c6.5.tgz  (install from local pkt)"
	echo "	$0  (install from internet)"
	echo ""
	exit
elif [ "$1" != "" ]; then
	INSTALLTYPE=1
fi

###غ
downfile_func()
{
	wget $1 -O $DOWNFILE -t3 -T9
	FILESIZE=`stat -c%s $DOWNFILE`
	if [ $FILESIZE -le 1 ]; then
		return 1  ###س
	else
		return 0
	fi
}


#######!!!װʼ!!!#######

if [ $INSTALLTYPE = 0 ] ; then
	####簲װжϲϵͳ
	###жϱҪ
	command -v wget >/dev/null 2>&1 || { echo >&2 "I require wget, but it's not installed. Aborting...you may run 'yum install wget(redhat/centos/etc...) OR apt-get install wget(debian/ubuntu/kali...)', and run this app again."; exit 1; }
	command -v tar >/dev/null 2>&1 || { echo >&2 "I require tar, but it's not installed. Aborting...you may run 'yum install tar(redhat/centos/etc...) OR apt-get install tar(debian/ubuntu/kali...)', and run this app again."; exit 1; }
	
	os=""
	vernum_main="0"
	vernum_sub="0"
	if [ -f "/etc/centos-release" ]; then  ###centos,ǰ
		os="c"
		osinfo=`cat /etc/centos-release`
		###CentOS Linux release 7.5.1804 (Core) 
		re="release ([0-9]+)\.([0-9]+).*"
		if [[ $osinfo =~ $re ]]; then
			vernum_main=${BASH_REMATCH[1]}
			vernum_sub=${BASH_REMATCH[2]}
		fi
		echo "Guess os is [CentOS], vernum=[$vernum_main.$vernum_sub]"

	elif [ -f "/etc/redhat-release" ]; then  ###redhat,CentOSжϺ
		osinfo=`cat /etc/redhat-release`
		###Red Hat Enterprise Linux Server release 6.5 (Santiago)
		re="(.*) .*release ([0-9]+)\.([0-9]+).*"
		if [[ $osinfo =~ $re ]]; then
			vernum_main=${BASH_REMATCH[2]}
			vernum_sub=${BASH_REMATCH[3]}
			if [ ${BASH_REMATCH[1]}" release" = "CentOS release" ]; then  ###CentOS5.11ûcentos-releaseļ
				os="c"
				echo "Guess os is [CentOS], vernum=[$vernum_main.$vernum_sub]"
			else
				os="r"
				echo "Guess os is [RedHat], vernum=[$vernum_main.$vernum_sub]"
			fi
		fi
		
	elif [ -f "/etc/debian_version" ]; then  ###debianubuntu
		debian=`cat /etc/issue|grep ebian`
		ubuntu=`cat /etc/issue|grep buntu`

		if [ "$debian" != "" ]; then
			os="d"
			osinfo=`cat /etc/debian_version`
			re="([0-9]+)\.([0-9]+).*"
			if [[ $osinfo =~ $re ]]; then
				vernum_main=${BASH_REMATCH[1]}
				vernum_sub=${BASH_REMATCH[2]}
			fi
			echo "Guess os is [Debian], vernum=[$vernum_main.$vernum_sub]"

		elif [ "$ubuntu" != "" ]; then
			os="u"
			osinfo=`cat /etc/issue`
			###Ubuntu 14.04.1 LTS \n \l
			re="([0-9]+)\.([0-9]+).*"
			if [[ $osinfo =~ $re ]]; then
				vernum_main=${BASH_REMATCH[1]}
				vernum_sub=${BASH_REMATCH[2]}
			fi
			echo "Guess os is [Ubuntu], vernum=[$vernum_main.$vernum_sub]"

		fi
	fi
	########ϵͳж########

	########ضӦ########
	PKTURL=$PKTURLBASE"mustc_$os$vernum_main.$vernum_sub.tgz"
	downfile_func "$PKTURL"
	if [ $? = 1 ]; then  ###δȡװԻȡ֧
		PKTURL=$PKTURLBASE"mustc_$os$vernum_main.tgz"
		downfile_func "$PKTURL"
		if [ $? = 1 ]; then
			echo "!!! Can not download install pkt, Please contact jiwo.ltd, exit ... !!!"
			echo ""
			exit
		fi
	fi
fi

#######ѹװ#######
if [ "$1" != "" ]; then
	srcpkt=$1
else
	srcpkt=$DOWNFILE
fi

tar zxvf $srcpkt -C /

chmod +x /JOS/musts/sbin -R
chmod +x /JOS/musts/bin -R

#export PATH="${PATH:+$PATH:}/JOS/musts/bin"
export PATH=$PATH:/JOS/musts/bin

##############
echo ""
echo "   ######################################################"
echo "   #                      config                        #"
echo "   ######################################################"
echo ""
echo "  Install mustc ok! Please config some arguments:"
echo ""

/JOS/musts/sbin/mustc_config.sh
echo ""
echo "Config end! Write autorun ..."

#######д#######
####rc.local
if [ -f "/etc/rc.local" -a -x "/etc/rc.local" ]; then
	exist=`cat /etc/rc.local|grep "/JOS/musts/sbin/start.sh"`
	if [ "$exist" = "" ]; then  ###
		exitsign=`cat /etc/rc.local|grep "^exit 0"`
		if [ "$exitsign" != "" ]; then  ####ȥexit 0ϵͳʱִк˳
			sed -i "s/^exit 0/\/JOS\/musts\/sbin\/start\.sh/g" /etc/rc.local
		else
			echo  "/JOS/musts/sbin/start.sh" >> /etc/rc.local
		fi
	else  ###䣬жǷע͵ע͵
		re="#.*"
		if [[ $exist =~ $re ]]; then
			sed -i "s/#.*\/JOS\/musts\/sbin\/start\.sh/\/JOS\/musts\/sbin\/start\.sh/g" /etc/rc.local
		fi
	fi
	echo ""
	echo "   ######################################################"
	echo "   #       !!! Write /etc/rc.local for autorun !!!      #"
	echo "   ######################################################"
	echo ""
else
	exist=`cat /etc/crontab|grep "/JOS/musts/sbin/start.sh"`
	if [ "$exist" = "" ]; then  ###䣬ÿ10 crondִ
		echo "*/10 *    * * *   root    /JOS/musts/sbin/start.sh" >> /etc/crontab
		crontab /etc/crontab
	else  ###䣬жǷע͵ע͵
		re="#.*"
		if [[ $exist =~ $re ]]; then
			sed -i "s/#.*\/JOS\/musts\/sbin\/start\.sh/*\/10 \*    \* \* \*   root    \/JOS\/musts\/sbin\/start\.sh/g" /etc/crontab
			crontab /etc/crontab
		fi
	fi
	echo ""
	echo "   ######################################################"
	echo "   #        !!! Write /etc/crontd for autorun !!!       #"
	echo "   ######################################################"
	echo ""
fi

#######̽#######
echo "end! Start mustc ..."
echo ""
/JOS/musts/sbin/start.sh "start"

runpid=`ps aux | grep mustc | grep -v grep | grep -v "install.sh" | awk '{print $2}'`
##if [ $? = 1 -a "$runpid" != "" ]; then  ####ֵstart.sh exit 1/0׼
if [ "$runpid" != "" ]; then
	echo ""
	echo "^_^ mustc start, Your server has been keeped !"
	echo ""
else
	echo ""
	echo "!!! Something wrong, Please contact jiwo.ltd !!!"
	echo ""
fi
